1#!/bin/bash
2#
3# Copyright (C) 2018 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9#     http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17function fail() {
18  echo Build failed: $1 1>&2
19  exit 1
20}
21
22if [[ -z "${ANDROID_BUILD_TOP}" ]]; then
23  fail "ANDROID_BUILD_TOP is not defined. Try running 'lunch' first."
24fi
25
26SCRIPT_PATH=$( cd $(dirname $0) ; pwd -P )
27ASM_CLASSPATH="${ANDROID_BUILD_TOP}/prebuilts/misc/common/asm/asm-9.6.jar"
28SRC_PATH="${SCRIPT_PATH}/src"
29BUILD_PATH="${1:-${SCRIPT_PATH}/classes}"
30
31if [[ ! -d "${BUILD_PATH}" ]]; then
32    mkdir "$BUILD_PATH" || exit 1
33fi
34
35# Build the initial class files.
36(cd "${SRC_PATH}" && ${JAVAC} ${JAVAC_ARGS} -source 8 -target 8 -cp "${ASM_CLASSPATH}" -d "${BUILD_PATH}" Main.java art/*.java art/constmethodhandle/*.java) || fail "javac error"
37# Modify the class files using ASM
38(cd "${SCRIPT_PATH}" && ${JAVA} -cp "${ASM_CLASSPATH}:${BUILD_PATH}" art.constmethodhandle.TestGenerator "${BUILD_PATH}" "$D8") || fail "generator failure"
39# Remove the modification classes. We don't need nor want them for the actual test.
40(cd ${BUILD_PATH} && find . -name "TestGenerator*.class" | xargs rm) || fail "Cleanup failure"
41